"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryPerformer = void 0;
class QueryPerformer {
    constructor(schema, gql, postgraphileQueryHandler, pool, contextOptions) {
        Object.defineProperty(this, "schema", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: schema
        });
        Object.defineProperty(this, "gql", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: gql
        });
        Object.defineProperty(this, "postgraphileQueryHandler", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: postgraphileQueryHandler
        });
        Object.defineProperty(this, "pool", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: pool
        });
        Object.defineProperty(this, "contextOptions", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: contextOptions
        });
        this.schema = schema;
        this.gql = gql;
        this.postgraphileQueryHandler = postgraphileQueryHandler;
        this.contextOptions = { ...contextOptions, pgPool: pool };
    }
    async perform(query, variables, operationName, jwtToken) {
        return await this.postgraphileQueryHandler({
            ...this.contextOptions,
            jwtToken
        }, async (context) => {
            return await this.gql(this.schema, query, null, { ...context }, variables, operationName);
        });
    }
}
exports.QueryPerformer = QueryPerformer;
